import * as i1 from '@angular-three/core';
import { DestroyedService, NgtCommonAudio, NgtObject3d, NGT_OBJECT_3D_CONTROLLER_PROVIDER } from '@angular-three/core';
import * as i0 from '@angular/core';
import { EventEmitter, Directive, SkipSelf, Input, Output, NgModule } from '@angular/core';
import { takeUntil } from 'rxjs/operators';
import * as THREE from 'three';

class NgtAudioListener {
    constructor(canvasStore, destroyed, ngZone) {
        this.canvasStore = canvasStore;
        this.destroyed = destroyed;
        this.ngZone = ngZone;
        this.ready = new EventEmitter();
    }
    ngOnInit() {
        this.ngZone.runOutsideAngular(() => {
            this._listener = new THREE.AudioListener();
            if (this.filter) {
                this._listener.filter = this.filter;
            }
            if (this.timeDelta) {
                this._listener.timeDelta = this.timeDelta;
            }
            this.canvasStore.selectors.internal$
                .pipe(takeUntil(this.destroyed))
                .subscribe(({ active }) => {
                this.ngZone.runOutsideAngular(() => {
                    const { camera } = this.canvasStore.getImperativeState();
                    if (active && camera) {
                        camera.add(this.audioListener);
                        this.ready.emit(this.audioListener);
                    }
                });
            });
        });
    }
    get audioListener() {
        return this._listener;
    }
}
NgtAudioListener.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioListener, deps: [{ token: i1.CanvasStore, skipSelf: true }, { token: i1.DestroyedService }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Directive });
NgtAudioListener.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.2", type: NgtAudioListener, selector: "ngt-audio-listener", inputs: { filter: "filter", timeDelta: "timeDelta" }, outputs: { ready: "ready" }, providers: [DestroyedService], exportAs: ["ngtAudioListener"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioListener, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-audio-listener',
                    exportAs: 'ngtAudioListener',
                    providers: [DestroyedService],
                }]
        }], ctorParameters: function () {
        return [{ type: i1.CanvasStore, decorators: [{
                        type: SkipSelf
                    }] }, { type: i1.DestroyedService }, { type: i0.NgZone }];
    }, propDecorators: { filter: [{
                type: Input
            }], timeDelta: [{
                type: Input
            }], ready: [{
                type: Output
            }] } });
class NgtAudioListenerModule {
}
NgtAudioListenerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioListenerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAudioListenerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioListenerModule, declarations: [NgtAudioListener], exports: [NgtAudioListener] });
NgtAudioListenerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioListenerModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioListenerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtAudioListener],
                    exports: [NgtAudioListener],
                }]
        }] });

// GENERATED
class NgtAudio extends NgtCommonAudio {
    constructor() {
        super(...arguments);
        this.audioType = THREE.Audio;
    }
}
NgtAudio.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudio, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtAudio.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.2", type: NgtAudio, selector: "ngt-audio", providers: [
        {
            provide: NgtCommonAudio,
            useExisting: NgtAudio,
        },
        {
            provide: NgtObject3d,
            useExisting: NgtAudio,
        },
        NGT_OBJECT_3D_CONTROLLER_PROVIDER,
    ], exportAs: ["ngtAudio"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudio, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-audio',
                    exportAs: 'ngtAudio',
                    providers: [
                        {
                            provide: NgtCommonAudio,
                            useExisting: NgtAudio,
                        },
                        {
                            provide: NgtObject3d,
                            useExisting: NgtAudio,
                        },
                        NGT_OBJECT_3D_CONTROLLER_PROVIDER,
                    ],
                }]
        }] });
class NgtAudioModule {
}
NgtAudioModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAudioModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioModule, declarations: [NgtAudio], exports: [NgtAudio] });
NgtAudioModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtAudioModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtAudio],
                    exports: [NgtAudio],
                }]
        }] });

// GENERATED
class NgtPositionalAudio extends NgtCommonAudio {
    constructor() {
        super(...arguments);
        this.audioType = THREE.PositionalAudio;
    }
}
NgtPositionalAudio.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtPositionalAudio, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtPositionalAudio.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.2", type: NgtPositionalAudio, selector: "ngt-positional-audio", providers: [
        {
            provide: NgtCommonAudio,
            useExisting: NgtPositionalAudio,
        },
        {
            provide: NgtObject3d,
            useExisting: NgtPositionalAudio,
        },
        NGT_OBJECT_3D_CONTROLLER_PROVIDER,
    ], exportAs: ["ngtPositionalAudio"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtPositionalAudio, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-positional-audio',
                    exportAs: 'ngtPositionalAudio',
                    providers: [
                        {
                            provide: NgtCommonAudio,
                            useExisting: NgtPositionalAudio,
                        },
                        {
                            provide: NgtObject3d,
                            useExisting: NgtPositionalAudio,
                        },
                        NGT_OBJECT_3D_CONTROLLER_PROVIDER,
                    ],
                }]
        }] });
class NgtPositionalAudioModule {
}
NgtPositionalAudioModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtPositionalAudioModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPositionalAudioModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtPositionalAudioModule, declarations: [NgtPositionalAudio], exports: [NgtPositionalAudio] });
NgtPositionalAudioModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtPositionalAudioModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtPositionalAudioModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtPositionalAudio],
                    exports: [NgtPositionalAudio],
                }]
        }] });

// GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtAudio, NgtAudioListener, NgtAudioListenerModule, NgtAudioModule, NgtPositionalAudio, NgtPositionalAudioModule };
