import { ComponentStore } from '@ngrx/component-store';
import { Observable, Subscription } from 'rxjs';
export declare type StoreState<TStore extends EnhancedComponentStore> = TStore extends EnhancedComponentStore<infer TComponentState> ? TComponentState : {};
export declare type StoreStateKeys<TState extends object> = Array<keyof TState & string>;
export declare type StoreSelectors<TState extends object> = {
    [K in StoreStateKeys<TState>[number] as `${K}$`]: Observable<TState[K]>;
};
export declare type StoreUpdaters<TState extends object> = {
    [K in StoreStateKeys<TState>[number] as `set${Capitalize<K>}`]: (value: TState[K]) => void;
};
export declare type AsyncStoreUpdaters<TState extends object> = {
    [K in StoreStateKeys<TState>[number] as `set${Capitalize<K>}`]: (observableValue: Observable<TState[K]>) => Subscription;
};
export declare function getSelectors<TStore extends EnhancedComponentStore>(store: TStore): StoreSelectors<StoreState<TStore>>;
export declare function capitalize<T extends string>(str: T): Capitalize<T>;
export declare function getUpdaters<TStore extends EnhancedComponentStore>(store: TStore): StoreUpdaters<StoreState<TStore>> & AsyncStoreUpdaters<StoreState<TStore>>;
export declare abstract class EnhancedComponentStore<TState extends object = any> extends ComponentStore<TState> {
    readonly selectors: StoreSelectors<TState>;
    readonly updaters: StoreUpdaters<TState> & AsyncStoreUpdaters<TState>;
    private readonly $imperative;
    protected constructor(state: TState);
    private readonly watchImperativeEffect;
    getImperativeState(): TState;
}
